package appserv;

import java.awt.*;
import java.applet.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;

public class dbapplet extends Applet implements ActionListener {

   TextField tfQuery;
   TextArea taResults;
   Button btnExecute;

   public void init() {

      Panel p1 = new Panel();
      p1.setLayout(new FlowLayout(FlowLayout.LEFT));

      p1.add(new Label("Query String:"));

      tfQuery = new TextField("SELECT * FROM vieraat", 50);
      p1.add(tfQuery);

      btnExecute = new Button("Execute Query");
      btnExecute.addActionListener(this);
      p1.add(btnExecute);

      add("North", p1);

      taResults = new TextArea(10, 80);
      add("Center", taResults);
   }

   public void executeQuery() {

      //luetaan SQL
      String qryString = tfQuery.getText();

      try {
         /* Luodaan yhteys servlettiin */
        URL url = new URL("http://192.168.23.20:8080/omat/servlet/appserv.dbappservlet");

         //kaikki HTTP-pyynnt pit koodata (encode)
         String qry = URLEncoder.encode("qry") + "=" +
                             URLEncoder.encode(qryString);

         //asetetaan vaadittavat asetukset
         URLConnection uc = url.openConnection();
         uc.setDoOutput(true);
         uc.setDoInput(true);
         uc.setUseCaches(false);
         uc.setRequestProperty("Content-type",
                             "application/x-www-form-urlencoded");

         // lhetetn pyynnt palvelimelle (eli ko. servletille)
         DataOutputStream dos = new DataOutputStream(uc.getOutputStream());
         dos.writeBytes(qry);
         dos.flush();
         dos.close();

         InputStreamReader in = new InputStreamReader(uc.getInputStream());

         //tyhjent aiemmat tulokset
         taResults.setText("");

         int chr = in.read();

         //luetaan vastaus palvelimelta, eli mit servletti tulostaa
         //HttpServletResponse.getWriter() virtaan (eli out)
         while (chr != -1) {
            taResults.append(String.valueOf((char) chr));
            chr = in.read();
         }
         in.close();

      } catch(MalformedURLException e) {
         taResults.setText(e.toString());
      } catch(IOException e) {
         taResults.setText(e.toString());
      }
   }
   //aina kun jotain tapahtuu niin suoritetaan, kuuntelijana vain btnExecute
   public void actionPerformed(ActionEvent ae) {
      executeQuery();
   }
}
